import os
import sys

import shlex
import subprocess

######################################################################################
######################################################################################
######################################################################################
# CLASS CONSOLE
class Console:
    def __init__(self):
        x=0
        #self.Message("Toto")
        
    def Error(self, string=""):
        print "[Error] ",
        print string
        print "Bye bye..."
        os.abort()

    def Warnin(self, string=""):
        print "[Warning] ",
        print string
        #os.abort()

    def Message(self, string=""):
        print "[Message] ",
        print string

    def AskYN(self, string=""):
        print string,
        print " [Y/n] ",
        ans = "Y"
        ans = raw_input()
        if (ans == "Y") or (ans == ""):
            return True
        else:
            return False

    def AskString(self,string=""):
        print string,
        #        print ": ",
        return raw_input()
    
######################################################################################
######################################################################################
######################################################################################
# CLASS SETUP
class Setup:
    _userhome = ""
    _ilpdir = ".ilptools"
    _absilpdir = ""
    _project_directory = "projects"
    _configfile = 'ilptools.cfg'
    _console = None
    _pinpath = ""
    _pinoptions = ""
    _pintoolpath = ""
    _pintoolname = ""
    _openedprojectfile = "openedprojects.cfg"
    _projecttoopen = []
    #    _pintoolpreferences = {}
    #    _pinresdir = ""
    def __init__(self,cons=None):
        if (cons == None):
            print "Internal Error console is needed"
            os.abort()
        self._console = cons    
        # CHECK for ILP DIRECTORY
        self._userhome = os.getenv("HOME")
        self._absilpdir = self._userhome + os.sep + self._ilpdir + os.sep        
        #        print "Check for ilp directory...   ",
        self.CheckDirectory(self._absilpdir)
        if (os.access(self._absilpdir,os.F_OK|os.R_OK|os.W_OK|os.X_OK)):
            self._console.Message("Check for ilp directory access...  OK")
        else:
            self._console.Message("Check for ilp directory access...  No")
            self._console.Error("application can not work without right accesses to .ilptools directory.")
            os.abort()
        # CHANGE DIR TO ILP DIRECTORY
        os.chdir(self._absilpdir)
        # CHECK for PROJECT DIRECTORY
        # CHECK CONFIGURATION FILE (ilptools.cfg)
        try:
            f = open(self._configfile,'r')
            self._console.Message("Check for configuration file... Ok")
            self._pinpath = f.readline().strip()
            self._pinoptions = f.readline().strip()
            self._pintoolpath = f.readline().strip()
            #            self._pinresdir = f.readline().strip()
        except IOError:
            self._console.Message("Check for configuration file... No")
            # if self._console.AskYN("Do you want to create it?"):
            # self._pinpath = self._console.AskString("Enter pin binary path")
            # self._pinoptions = self._console.AskString("Enter general pin options")
            # self._pintoolpath = self._console.AskString("Enter pintool path")
            #                self._pinresdir = self._console.AskString("Enter pin result directory")
            f = open(self._configfile,'w')
            f.write(self._pinpath)
            f.write("\n")
            f.write(self._pinoptions)
            f.write("\n")
            f.write(self._pintoolpath)
            f.write("\n")
            self._console.Message("Building configuration file...")
            #                f.write(self._pinresdir)
            #                f.write("\n")
        try:
            f = open(self._openedprojectfile,'r')
            #            while proj = f.readline().strip():
            for line in f.readlines():
                self._projecttoopen.append(line.strip())
                print line
        except IOError:
            print "No file to open..."
            pass
        # CHECK PROJECT DIRECTORY
        self.CheckDirectory(self._project_directory)
        # CHANGE DIR TO PROJECT DIRECTORY
        os.chdir(self._project_directory)

    def CheckDirectory(self, dir=None):
        if dir==None:
            self._console.Error("Internal Error: set a directory to create")
        else:
            if (os.access(dir,os.F_OK)):
                self._console.Message("Check for "+dir+" directory...   OK")
            else:
                self._console.Message("Check for "+dir+" directory...   No")
                # if self._console.AskYN("Do you want to create "+dir+" directory?"):
                os.mkdir(dir)
                self._console.Message("Building "+dir+" directory...")
                #     self._console.Message(dir+" created...   ")
                # else:
                #     self._console.Error("application can not work without "+dir+".")
                    

    def SavePreferences(self):
        os.chdir(self._absilpdir)
 
        f = open(self._configfile,'w')
        f.write(self._pinpath)
        f.write("\n")
        f.write(self._pinoptions)
        f.write("\n")
        f.write(self._pintoolpath)
        f.write("\n")
        #        f.write(self._pinresdir)
        #        f.write("\n")

        os.chdir(self._project_directory)
        pass


    def Quit(self, openedprojects = []):
        os.chdir(self._absilpdir)
        f = open(self._openedprojectfile,'w')
        for fname in openedprojects:
            f.write(fname)
            f.write("\n")
        f.close()


        
######################################################################################
######################################################################################
######################################################################################
