#import pygtk
#pygtk.require('2.0')
import gtk

import gobject
import pango
import Gnuplot
import os.path

import networkx
#import matplotlib
import matplotlib.pylab as plt

class ILPShow:
    _my_color_map = ["#000000" ,
                     "#00008B" ,
                     "#008B8B" ,
                     "#00008B" ,
                     "#008B8B" ,
                     "#B8860B" ,
                     "#A9A9A9" ,
                     "#006400" ,
                     "#BDB76B" ,
                     "#8B008B" ,
                     "#556B2F" ,
                     "#FF8C00" ,
                     "#9932CC" ,
                     "#8B0000" ,
                     "#E9967A" ,
                     "#8FBC8F" ,
                     "#483D8B" ,
                     "#2F4F4F" ,
                     "#00CED1" ,
                     "#9400D3" ,
                     "#FF1493" ,
                     "#00BFFF" ,
                     "#696969" ,
                     "#1E90FF" ,
                     "#B22222" ,
                     "#228B22" ,
                     "#FF00FF" ,
                     "#0000FF" ,
                     "#8A2BE2" ,
                     "#A52A2A" ,
                     "#DEB887" ,
                     "#5F9EA0" ,
                     "#7FFF00" ,
                     "#D2691E" ,
                     "#FF7F50" ,
                     "#6495ED" ,
                     "#DC143C" ,
                     "#558833" ,
                     "#00FFFF" ,
                     "#FF4500" ,
                     "#2E8B57" ,
                     "#FF0000" ,
                     "#F00000" ,
                     "#E00000" ,
                     "#D00000" ,
                     "#C00000" ,
                     "#B00000" ,
                     "#A00000" , 
                     "#900000" ,
                     "#800000" ,
                     "#700000" ,
                     "#600000" ,
                     "#500000"
                  ]


    _instruction_category = ["INVALID",
                             "3DNOW",
                             "AES",
                             "AVX",
                             "AVX2",
                             "AVX2GATHER",
                             "BINARY",
                             "BITBYTE",
                             "BMI1",
                             "BMI2",
                             "BROADCAST",
                             "CALL",
                             "CMOV",
                             "CONDBR",
                             "CONVERT",
                             "DATAXFER",
                             "DECIMAL",
                             "FCMOV",
                             "FLAGOP",
                             "INTERRUPT",
                             "IO",
                             "IOSTRINGOP",
                             "LOGICAL",
                             "LZCNT",
                             "MISC",
                             "MMX",
                             "NOP",
                             "PCLMULQDQ",
                             "POP",
                             "PREFETCH",
                             "PUSH",
                             "RDRAND",
                             "RDWRFSGS",
                             "RET",
                             "ROTATE",
                             "SEGOP",
                             "SEMAPHORE",
                             "SHIFT",
                             "SSE",
                             "STRINGOP",
                             "STTNI",
                             "SYSCALL",
                             "SYSRET",
                             "SYSTEM",
                             "UNCONDBR",
                             "VFMA",
                             "VTX",
                             "WIDENOP",
                             "X87_ALU",
                             "XSAVE",
                             "XSAVEOPT",
                             "LAST"
                             ]


    def SetColors(self, gp=None, hname=None):
        name = hname + '.colmap'
        ic = 1
        infile = open(name,'r')
        i =  1
        #        for i in range(1, 39):
        for lines in infile.readlines():
            if lines[0] == '1':
                cmd = "set style line "+str(ic)+"   linecolor rgbcolor \""+self._my_color_map[i]+"\""
                gp(cmd)
                ic = ic + 1
            i = i + 1;
        gp('set style increment user')
        return ic
#     def SetColors(self, gp=None):
#         for i in range(1, 39):
#             cmd = "set style line "+str(i)+"   linecolor rgbcolor \""+self._my_color_map[i]+"\""
#             gp(cmd)
#         gp('set style increment user')
        
    def ViewProfile(self,profilename):
        infile = open(profilename,'r')
        if infile:
            text = infile.read()
            return text
        return None
        pass

### VIEW EPS HISTO
    def ViewHistogram(self, histoname):
        _gp = Gnuplot.Gnuplot(persist = 1)

        #_gp('set term x11')
        _gp('set term wxt')

        #############################################################
        # OPTIONS for EPS output
        #############################################################
#         _gp('set terminal postscript eps color "Sans-Serif" 16')
#         outcmd = "set output '"+histoname+".eps'"
#         _gp(outcmd)
#         _gp('set xrange [500:520]')
#         _gp('set yrange [0:5]')
        #############################################################


        _gp('set key spacing 0.5 font "Times-Roman,5"')
        columns = self.SetColors(_gp,histoname)
        
        _gp("set xlabel 'cycles'")
        _gp("set ylabel 'ILP'")
        titlecmd = "set title '"+os.path.basename(histoname)+"'"
        _gp(titlecmd)
        
        _gp('set boxwidth 1.0 absolute')

        _gp('set style fill   solid 1.00 noborder')
        _gp('set key outside right top vertical Left reverse enhanced autotitles columnhead nobox')
        #_gp('set key outside right top vertical Left reverse enhanced nobox')
        _gp('set key invert samplen 1 spacing 1 width 0 height 0 font "Times-Roman,8"')
        _gp('set style histogram rowstacked title  offset character 0, 0, 0')
        _gp('set datafile missing \'-\'')
        _gp('set style data histograms')

        #_gp('set xrange [0:1000]')
        
        #        gpcommand = "plot \""+histoname+"\" using 2, '' using 3, '' using 4 title '"+histoname+"'"
        #        gpcommand = "plot '"+histoname+"' using 2:xtic(1), for [i=3:39] '' using i"
        #        gpcommand = "plot '"+histoname+"' using 2, for [i=3:39] '' using i"

        #        gpcommand = "plot '"+histoname+"' using 2, for [i=3:"+str(columns)+"] '' using i"
        gpcommand = "plot for [i=2:"+str(columns)+"] '"+histoname+"' using i"
        _gp(gpcommand)
        pass


    def ViewEPSHistogram(self, histoname, htitle="blank title", xmin="0", xmax="1", ymin="0", ymax="1"):
        _gp = Gnuplot.Gnuplot(persist = 1)
        
        #_gp('set term x11')
        #_gp('set term wxt')
        
        #############################################################
        # OPTIONS for EPS output
        #############################################################
        _gp('set terminal postscript eps color "Sans-Serif" 16')
        outcmd = "set output '"+histoname+".eps'"
        _gp(outcmd)
#        if ((xmin < xmax) and (ymin < ymax)):
        outcmd = "set xrange ["+xmin+":"+xmax+"]"
#        print outcmd
        _gp(outcmd)
        outcmd = "set yrange ["+ymin+":"+ymax+"]"
#        print outcmd
        _gp(outcmd)
        #         _gp('set xrange [500:520]')
        #         _gp('set yrange [0:5]')
        #############################################################
        #        pass
        
        _gp('set key spacing 0.5 font "Times-Roman,5"')
        columns = self.SetColors(_gp,histoname)
        
        _gp("set xlabel 'cycles'")
        _gp("set ylabel 'ILP'")
        #titlecmd = "set title '"+os.path.basename(histoname)+" ~~~  "+htitle+"'"
        titlecmd = "set title '"+htitle+"'"
        _gp(titlecmd)
        
        _gp('set boxwidth 1.0 absolute')

        _gp('set style fill   solid 1.00 noborder')
        _gp('set key outside right top vertical Left reverse enhanced autotitles columnhead nobox')
        #_gp('set key outside right top vertical Left reverse enhanced nobox')
        _gp('set key invert samplen 1 spacing 1 width 0 height 0 font "Times-Roman,8"')
        _gp('set style histogram rowstacked title  offset character 0, 0, 0')
        _gp('set datafile missing \'-\'')
        _gp('set style data histograms')

        #_gp('set xrange [0:1000]')
        
        #        gpcommand = "plot \""+histoname+"\" using 2, '' using 3, '' using 4 title '"+histoname+"'"
        #        gpcommand = "plot '"+histoname+"' using 2:xtic(1), for [i=3:39] '' using i"
        #        gpcommand = "plot '"+histoname+"' using 2, for [i=3:39] '' using i"

        #        gpcommand = "plot '"+histoname+"' using 2, for [i=3:"+str(columns)+"] '' using i"
        outcmd = "set xrange ["+xmin+":"+xmax+"]"
        _gp(outcmd)
        outcmd = "set yrange ["+ymin+":"+ymax+"]"
        _gp(outcmd)

        gpcommand = "plot for [i=2:"+str(columns)+"] '"+histoname+"' using i"
        _gp(gpcommand)
        pass
#### END VIEW EPS

    def ViewShortHistogram(self, histoname):
        _gp = Gnuplot.Gnuplot(persist = 1)

        #_gp('set term x11')
        _gp('set term wxt')
        _gp('set key spacing 0.5 font "Times-Roman,5"')
        #self.SetColors(_gp)
        
        _gp("set xlabel 'cycles'")
        _gp("set ylabel 'ILP'")

        _gp('set boxwidth 1.0 absolute')

        #        _gp('set style fill   solid 1.00 noborder')
        #        _gp('set key outside right top vertical Left reverse enhanced autotitles columnhead nobox')
        _gp('set key outside right top vertical Left enhanced autotitles columnhead nobox')
        _gp('set key samplen 1 spacing 1 width 0 height 0 font "Times-Roman,8"')
        #        _gp('set style histogram rowstacked title  offset character 0, 0, 0')
        _gp('set datafile missing \'-\'')
        _gp('set style data linespoints')
        #        _gp('set xtics auto')
        #        _gp('set auto yrange')
        #_gp('set xrange [0:1000]')
        
        #        gpcommand = "plot \""+histoname+"\" using 2, '' using 3, '' using 4 title '"+histoname+"'"
        #        gpcommand = "plot '"+histoname+"' using 2:xtic(1), for [i=3:39] '' using i"
        #        gpcommand = "plot '"+histoname+"' using 2, for [i=3:39] '' using i"
        #        gpcommand = "plot '"+histoname+"' using 2:xtic(1)"
        #        gpcommand = "plot '"+histoname+"' using 2:xtics(1)"
        gpcommand = "plot '"+histoname+"' using 1:2"
        _gp(gpcommand)
        pass

    def ViewTraceA(self, tracename):
        # GRAPH BUILD TEST
        POS = {}
        LABELS = {}
        STACKPOS = {}
        CATEGORY = {}
        for i in range(40):
            CATEGORY[str(i)] = []
        EDGE_REG = []
        EDGE_MEM = []
        fic = open(tracename, 'r')
        G = networkx.DiGraph()
        #        while line = fic.readline():
        for line in fic.readlines():
            #print CATEGORY
            instr = line.split()
            G.add_node(instr[0])
            #, cycle=instr[1], opcode=instr[6])
            if (instr[7] != '0'):
                G.add_edge(instr[0],instr[7])
                EDGE_REG.append((instr[0],instr[7]))
            if (instr[8] != '0'):
                G.add_edge(instr[0],instr[8])
                EDGE_REG.append((instr[0],instr[8]))
            if (instr[9] != '0'):
                G.add_edge(instr[0],instr[9])
                EDGE_REG.append((instr[0],instr[9]))
            if (instr[10] != '0'):
                G.add_edge(instr[0],instr[10])
                EDGE_REG.append((instr[0],instr[10]))
            if (instr[11] != '0'):
                G.add_edge(instr[0],instr[11])
                EDGE_MEM.append((instr[0],instr[11]))
            if (instr[12] != '0'):
                G.add_edge(instr[0],instr[12])
                EDGE_MEM.append((instr[0],instr[12]))

            if instr[1] in STACKPOS:
                STACKPOS[instr[1]] = STACKPOS[instr[1]] + 1
            else:
                STACKPOS[instr[1]] = 0;
            # POS[instr[0]] = [int(instr[0]),int(instr[1])]
            POS[instr[0]] = [STACKPOS[instr[1]],-int(instr[1])]
            LABELS[instr[0]] = instr[0] + ":\n" + instr[6]
            if instr[3] not in CATEGORY:
                CATEGORY[instr[3]] = []
            CATEGORY[instr[3]].append(instr[0])
        G.remove_node("0")
        #        networkx.draw(G, pos=POS, labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #print CATEGORY
        for key in CATEGORY:
            #print key
            # With LABELS
            #networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
            #                             labels=LABELS, node_size=1100, node_shape='s',font_size=6)
            # Without LABELS
            networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
                                         node_size=1100, node_shape='s',font_size=6)
            # NODE SHAPES: so^>v<dph8 + x
            #             networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key],
            #                           labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_REG, edge_color='black', alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_MEM, edge_color='red', alpha=0.5)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_labels(G, pos=POS, labels=LABELS, font_size=6)
        plt.axis('off')
        plt.show()
        pass

    def print_selected(self, treeselection):
        (model,pathlist)=treeselection.get_selected_rows()
        print pathlist

    def ViewTraceS(self, tracename, parent):
        dial = gtk.Dialog("Select Category", parent, gtk.DIALOG_MODAL,
                          (gtk.STOCK_OK, gtk.RESPONSE_OK,
                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
        
        dial.resize(320,10)
        sellist = gtk.ListStore(gobject.TYPE_STRING)
        for i in range(39):
            sellist.append((self._instruction_category[i],))
            
        treeview = gtk.TreeView()
        treeview.set_model(sellist)
        treeview.modify_font(pango.FontDescription("Courier New italic 8"))
        column = gtk.TreeViewColumn()
        cell = gtk.CellRendererText()
        column.pack_start(cell)
        column.add_attribute(cell,'text',0)
        treeview.append_column(column)
        
        treeview.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
            
        #        treeview.get_selection().connect('changed',lambda s: self.print_selected(s))

        #        dial.add(treeview)
        scrollwin = gtk.ScrolledWindow()
        scrollwin.add(treeview)
        #        dial.vbox.pack_start(treeview)
        dial.vbox.pack_start(scrollwin)
        dial.resize(320,480)
        dial.show_all()
        reponse = dial.run()
        (model, path) = (None, None)
        if reponse == gtk.RESPONSE_OK:
            # L'utilisateur valide
            treeselection = treeview.get_selection()
            (model, selrows) = treeselection.get_selected_rows()
            #print selrows
            #(model,pathlist)=treeview.get_selected_rows()
            pass
        else:
            #      print "Bad response !!!"
            pass
        dial.destroy()
        
        # GRAPH BUILD TEST
        POS = {}
        LABELS = {}
        CATLABELS = {}
        STACKPOS = {}
        CATEGORY = {}
        for i in range(40):
            CATEGORY[str(i)] = []
        for i in range(40):
            CATLABELS[str(i)] = {}
        EDGE_REG = []
        EDGE_MEM = []
        fic = open(tracename, 'r')
        G = networkx.DiGraph()
        #        while line = fic.readline():
        for line in fic.readlines():
            instr = line.split()
            G.add_node(instr[0])
            #, cycle=instr[1], opcode=instr[6])
            if (instr[7] != '0'):
                G.add_edge(instr[0],instr[7])
                EDGE_REG.append((instr[0],instr[7]))
            if (instr[8] != '0'):
                G.add_edge(instr[0],instr[8])
                EDGE_REG.append((instr[0],instr[8]))
            if (instr[9] != '0'):
                G.add_edge(instr[0],instr[9])
                EDGE_REG.append((instr[0],instr[9]))
            if (instr[10] != '0'):
                G.add_edge(instr[0],instr[10])
                EDGE_REG.append((instr[0],instr[10]))
            if (instr[11] != '0'):
                G.add_edge(instr[0],instr[11])
                EDGE_MEM.append((instr[0],instr[11]))
            if (instr[12] != '0'):
                G.add_edge(instr[0],instr[12])
                EDGE_MEM.append((instr[0],instr[12]))

            if instr[1] in STACKPOS:
                STACKPOS[instr[1]] = STACKPOS[instr[1]] + 1
            else:
                STACKPOS[instr[1]] = 0;
            # POS[instr[0]] = [int(instr[0]),int(instr[1])]
            POS[instr[0]] = [STACKPOS[instr[1]],-int(instr[1])]
            CATLABELS[instr[3]][instr[0]] = instr[6]
            CATEGORY[instr[3]].append(instr[0])
        G.remove_node("0")
        #        networkx.draw(G, pos=POS, labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #print CATEGORY
        
        SelectedCat = []
        for row in selrows:
            Cat = str(row[0])
            SelectedCat.append(Cat) 
        #        SelectedCat = ['3','8','28']
        #        print SelectedCat
        SG = None
        for key in CATEGORY:
            if key in SelectedCat:
                SG = networkx.subgraph(G,CATEGORY[key])
                networkx.draw(SG, pos=POS, labels=CATLABELS[key], node_color=self._my_color_map[int(key)+1], node_size=600, node_shape='s',font_size=6, alpha=1.0)
            else:
                SG = networkx.subgraph(G,CATEGORY[key])
                networkx.draw(SG, pos=POS, labels=CATLABELS[key], node_color=self._my_color_map[int(key)+1], node_size=600, node_shape='s',font_size=6, alpha=0.1)
                
#                 networkx.draw_networkx_nodes(SG, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)],
#                                              labels=LABELS, node_size=600, node_shape='s',font_size=6)
#                 networkx.draw_networkx_labels(SG, pos=POS, nodelist=CATEGORY[key], labels=CATLABELS[key], font_size=6)
#         networkx.draw_networkx_edges(SG,pos=POS, edgelist=EDGE_REG, edge_color='black', alpha=0.5)
#         networkx.draw_networkx_edges(SG,pos=POS, edgelist=EDGE_MEM, edge_color='red', alpha=0.5)
        plt.axis('off')
        plt.show()
        pass


    def ViewTraceG(self, tracename):
        # GRAPH BUILD TEST
        POS = {}
        LABELS = {}
        STACKPOS = {}
        CATEGORY = {}
        for i in range(40):
            CATEGORY[str(i)] = []
        EDGE_REG = []
        EDGE_MEM = []
        fic = open(tracename, 'r')
        G = networkx.DiGraph()
        #        while line = fic.readline():
        lastcycle = 0
        for line in fic.readlines():
            #print CATEGORY
            instr = line.split()
            G.add_node(instr[0])
            #, cycle=instr[1], opcode=instr[6])
            if (instr[7] != '0'):
                G.add_edge(instr[0],instr[7])
                EDGE_REG.append((instr[0],instr[7]))
            if (instr[8] != '0'):
                G.add_edge(instr[0],instr[8])
                EDGE_REG.append((instr[0],instr[8]))
            if (instr[9] != '0'):
                G.add_edge(instr[0],instr[9])
                EDGE_REG.append((instr[0],instr[9]))
            if (instr[10] != '0'):
                G.add_edge(instr[0],instr[10])
                EDGE_REG.append((instr[0],instr[10]))
            if (instr[11] != '0'):
                G.add_edge(instr[0],instr[11])
                EDGE_MEM.append((instr[0],instr[11]))
            if (instr[12] != '0'):
                G.add_edge(instr[0],instr[12])
                EDGE_MEM.append((instr[0],instr[12]))

            if instr[1] in STACKPOS:
                STACKPOS[instr[1]] = STACKPOS[instr[1]] + 1
            else:
                STACKPOS[instr[1]] = 0;
            # POS[instr[0]] = [int(instr[0]),int(instr[1])]
            POS[instr[0]] = [STACKPOS[instr[1]],-int(instr[1])]
            LABELS[instr[0]] = instr[0] + ":\n" + instr[6]
            if instr[3] not in CATEGORY:
                CATEGORY[instr[3]] = []
            CATEGORY[instr[3]].append(instr[0])
            if (int(instr[1]) > lastcycle):
                lastinstr = instr[0]
                lastcycle = int(instr[1])

        #Nodes = networkx.node_connected_component(G, lastinstr)
        #        AG = networkx.algorithms.components.weakly_connected_component_subgraphs(G)
        #        AG = networkx.algorithms.components.strongly_connected.condensation(G)
        #        AG = networkx.make_max_clique_graph(G)
        #        AG = networkx.cliques_containing_node(G,lastinstr)
        SP = networkx.shortest_path(G,lastinstr,"1")
        print SP
        print
        #        NG = networkx.DiGraph(SP)
        AG = networkx.DiGraph.subgraph(G, SP)
        print AG
        print
        print AG.nodes()
        #        print AG
        #        RG = AG
#         RG = AG[0]
#         for graph in AG:
#             print graph.nodes()
#             #        RG = networkx.algorithms.component.number_strongly_connected_components(G)
#         print
#         print RG.nodes()
        RG = AG
        #shortpath = shortest_path(G, "0", lastinstr)
#         RG = G
#         while networkx.shortest_path_length(RG,lastinstr, "1") < lastcycle:
#             nodelist = networkx.shortest_path(RG, lastinstr, "1")
#             nodelist.remove("1")
#             nodelist.remove(lastinstr)
#             print nodelist
#             RG.remove_nodes_from(nodelist)

        #        G.remove_node("0")
        networkx.draw(RG, pos=None, labels=None, node_size=600, node_shape='s',font_size=6)
        #print CATEGORY
        for key in CATEGORY:
            #print key
            # With LABELS
            #networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
            #                             labels=LABELS, node_size=1100, node_shape='s',font_size=6)
            # Without LABELS
            
            networkx.draw_networkx_nodes(AG, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
                                         node_size=1100, node_shape='s',font_size=6)
            # NODE SHAPES: so^>v<dph8 + x
            #             networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key],
            #                           labels=LABELS, node_size=600, node_shape='s',font_size=6)
            #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_edges(RG,pos=POS, edgelist=EDGE_REG, edge_color='black', alpha=0.5)
        networkx.draw_networkx_edges(RG,pos=POS, edgelist=EDGE_MEM, edge_color='red', alpha=0.5)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_labels(RG, pos=POS, labels=LABELS, font_size=6)
        plt.axis('off')
        plt.show()
        pass

    def ViewTraceG_VERSION_002(self, tracename):
        # GRAPH BUILD TEST
        #        CURRENT_CYCLE_ID = 0
        #        CYCLE_ID = {}
        POS = {}
        LABELS = {}
        STACKPOS = {}
        CATEGORY = {}
        EXEC_COUNT = {}
        for i in range(40):
            CATEGORY[str(i)] = []
        EDGE_REG = []
        EDGE_MEM = []
        fic = open(tracename, 'r')
        G = networkx.DiGraph()
        #        while line = fic.readline():
        Lines = fic.readlines()
        #        for line in fic.readlines():
        for line in Lines:
            instr = line.split()
            if instr[13] in G:
                EXEC_COUNT[instr[13]] = EXEC_COUNT[instr[13]] + 1
                pass
            else:
                EXEC_COUNT[instr[13]] = 1
                G.add_node(instr[13])
                
                if instr[1] in STACKPOS:
                    STACKPOS[instr[1]] = STACKPOS[instr[1]] + 1
                else:
                    STACKPOS[instr[1]] = 0;
                # POS[instr[0]] = [int(instr[0]),int(instr[1])]
                POS[instr[13]] = [STACKPOS[instr[1]],-int(instr[1])]
                LABELS[instr[13]] = instr[6]
                CATEGORY[instr[3]].append(instr[13])

        for line in Lines:
            instr = line.split()
            LABELS[instr[13]] = instr[6] + ' [' + str(EXEC_COUNT[instr[13]]) +']'
            
            #            print instr
            #             G.add_node(instr)
            #             if (instr[7] != '0'):
            #                 G.add_edge(instr[0],instr[7])
            #                 EDGE_REG.append((instr[0],instr[7]))
            #             if (instr[8] != '0'):
            #                 G.add_edge(instr[0],instr[8])
            #                 EDGE_REG.append((instr[0],instr[8]))
            #             if (instr[9] != '0'):
            #                 G.add_edge(instr[0],instr[9])
            #                 EDGE_REG.append((instr[0],instr[9]))
            #             if (instr[10] != '0'):
            #                 G.add_edge(instr[0],instr[10])
            #                 EDGE_REG.append((instr[0],instr[10]))
            #             if (instr[11] != '0'):
            #                 G.add_edge(instr[0],instr[11])
            #                 EDGE_MEM.append((instr[0],instr[11]))
            #             if (instr[12] != '0'):
            #                 G.add_edge(instr[0],instr[12])
            #                 EDGE_MEM.append((instr[0],instr[12]))
            


        #        G.remove_node("0")
        #        networkx.draw(G, pos=POS, labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #print CATEGORY
        for key in CATEGORY:
            #print key
            networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
                          labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_REG, edge_color='black', alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_MEM, edge_color='red', alpha=0.5)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_labels(G, pos=POS, labels=LABELS, font_size=6)
        plt.axis('off')
        plt.show()
        pass

    def ViewTraceG_OLD(self, tracename):
        # GRAPH BUILD TEST
        POS = {}
        LABELS = {}
        STACKPOS = {}
        CATEGORY = {}
        for i in range(40):
            CATEGORY[str(i)] = []
        EDGE_REG = []
        EDGE_MEM = []
        fic = open(tracename, 'r')
        G = networkx.DiGraph()
        #        while line = fic.readline():
        Lines = fic.readlines()
        #        for line in fic.readlines():
        for line in Lines:
            instr = line.split()
            #             for i in range(7,13):
            #                 #                instr[i] = int(instr[0]) - int(instr[i])
            #                 if instr[i] != '0':
            #                     instr.append(int(instr[i]) - int(instr[0]))
            #                 else:
            #                     instr.append(0)
            #             #            G.add_node(instr[0])
            if instr[13] in G:
                pass
            else:
                G.add_node(instr[13])
                
            #            print instr
            #             G.add_node(instr)
            #             if (instr[7] != '0'):
            #                 G.add_edge(instr[0],instr[7])
            #                 EDGE_REG.append((instr[0],instr[7]))
            #             if (instr[8] != '0'):
            #                 G.add_edge(instr[0],instr[8])
            #                 EDGE_REG.append((instr[0],instr[8]))
            #             if (instr[9] != '0'):
            #                 G.add_edge(instr[0],instr[9])
            #                 EDGE_REG.append((instr[0],instr[9]))
            #             if (instr[10] != '0'):
            #                 G.add_edge(instr[0],instr[10])
            #                 EDGE_REG.append((instr[0],instr[10]))
            #             if (instr[11] != '0'):
            #                 G.add_edge(instr[0],instr[11])
            #                 EDGE_MEM.append((instr[0],instr[11]))
            #             if (instr[12] != '0'):
            #                 G.add_edge(instr[0],instr[12])
            #                 EDGE_MEM.append((instr[0],instr[12]))
            
            if instr[1] in STACKPOS:
                STACKPOS[instr[1]] = STACKPOS[instr[1]] + 1
            else:
                STACKPOS[instr[1]] = 0;
            # POS[instr[0]] = [int(instr[0]),int(instr[1])]
            POS[instr[13]] = [STACKPOS[instr[1]],-int(instr[1])]
            LABELS[instr[13]] = instr[6]
            CATEGORY[instr[3]].append(instr[13])
        #        G.remove_node("0")
        #        networkx.draw(G, pos=POS, labels=LABELS, node_size=600, node_shape='s',font_size=6)
        #print CATEGORY
        for key in CATEGORY:
            #print key
            # DRAW With LABELS
            #             networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
            #                                          labels=LABELS, node_size=600, node_shape='s',font_size=6)
            # DRAW Without LABELS
            networkx.draw_networkx_nodes(G, pos=POS, nodelist=CATEGORY[key], node_color=self._my_color_map[int(key)+1],
                                         node_size=600, node_shape='s',font_size=6)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_REG, edge_color='black', alpha=0.5)
        networkx.draw_networkx_edges(G,pos=POS, edgelist=EDGE_MEM, edge_color='red', alpha=0.5)
        #        networkx.draw_networkx_edges(G,pos=POS, alpha=0.5)
        networkx.draw_networkx_labels(G, pos=POS, labels=LABELS, font_size=6)
        plt.axis('off')
        plt.show()
        pass


    
