#!/usr/bin/env python
# -*- coding:utf-8 -*-

# try:
#   import pygtk
#   pygtk.require('2.0')
# except:
#   print "Error: program can not run whitout pygtk."
  
try:
  import gtk
except:
  print "Error: program can not run whitout gtk."
  sys.exit(1)
  

import os
#import ilpclasses
#import ILPModel
import pango

import ILPShow

class ProjectNotebook(gtk.Notebook):

  def __init__(self, projectmanager):
    gtk.Notebook.__init__(self)
    #set the tab properties
    self.set_property('homogeneous', True)
    #we do not show the tab if there is only one tab i total
    self.set_property('show-tabs', True) 
    self._projectmanager = projectmanager
    
  def create_new_tab(self, index=None):
    #    print '[DEBUG NEW]: index = ', index
    page = gtk.VBox()
    entry = {}
    labels = {}
    for key in self._projectmanager._project_list[index]._project_component_keys:
      markuptext = '<span font_desc="Courier New bold 10" foreground="blue" underline="low">' + key + '</span>'
      (attrs, txt, car) = pango.parse_markup(markuptext)
      labels[key] = gtk.Label(txt)
      labels[key].set_attributes(attrs)
      #      labels[key].modify_font(pango.FontDescription("Courier New italic bold 10"))
      # (attrs, txt, car) = pango.parse_markup('<span foreground="blue" underline="single">Text</span>', accel_marker=u'\x00')
      # (attrs, txt, car) = pango.parse_markup('<span foreground="blue" underline="single">Text</span>')
      
      entry[key] = gtk.Label(self._projectmanager._project_list[index]._project_components[key])
  
    for key in (self._projectmanager._project_list[index])._project_component_keys:
      page.pack_start(labels[key])
      page.pack_start(entry[key])
      page.pack_start(gtk.HSeparator())
    self.insert_page(page, None, index)

    page_label = self.create_tab_label(self._projectmanager._project_list[index]._project_components['name'], page)
    page_label.show_all()

    self.set_tab_label_packing(page_label, True, True, gtk.PACK_START)
    self.set_tab_label(page, page_label)
    page.show_all()

    self.set_current_page(index)

  def create_tab_label(self, title, tab_child):
    box = gtk.HBox()
    icon = gtk.Image()
    icon.set_from_stock(gtk.STOCK_ABOUT, gtk.ICON_SIZE_MENU)
    label = gtk.Label(title)
    closebtn = gtk.Button()
    #the close button is made of an empty button
    #where we set an image
    image = gtk.Image()
    image.set_from_stock(gtk.STOCK_CLOSE, gtk.ICON_SIZE_MENU)
    closebtn.connect("clicked", self.close_tab, tab_child)
    closebtn.set_image(image)
    closebtn.set_relief(gtk.RELIEF_NONE)
    box.pack_start(icon, False, False)
    box.pack_start(label, True, True)
    box.pack_end(closebtn, False, False)
    return box

  def close_tab(self, widget, child):
    pagenum = self.page_num(child)
    if pagenum != -1:
      self.remove_page(pagenum)
      child.destroy()
      #      print 'Destroy page number ', pagenum  
      self._projectmanager.Remove(pagenum)
      
  def edit(self, parent):
    index = self.get_current_page()

    #    print '[DEBUG EDIT]: index = ', index
    #    dial = gtk.Dialog("Edit", parent, gtk.DIALOG_MODAL,
    dial = gtk.Dialog("Edit", parent, gtk.DIALOG_MODAL,
                      (gtk.STOCK_OK, gtk.RESPONSE_OK,
                       gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
    dial.resize(480,300)
    #    dial.set_size_request(480,200)
    # Creation de la zone de saisie
    entry = {}
    labels = {}
    for key in self._projectmanager._project_list[index]._project_component_keys:
      labels[key] = gtk.Label(key)
      labels[key].modify_font(pango.FontDescription("Courier New italic bold 10"))
      entry[key] = gtk.Entry()
      entry[key].set_text(self._projectmanager._project_list[index]._project_components[key])
    for key in self._projectmanager._project_list[index]._project_component_keys:
      dial.vbox.pack_start(labels[key])
      dial.vbox.pack_start(entry[key], True, False, 0)
    
    dial.vbox.show_all()
    # On lance la boite de dialogue et on recupere la reponse
    reponse = dial.run()
    if reponse == gtk.RESPONSE_OK:
      # L'utilisateur valide
      for key in self._projectmanager._project_list[index]._project_component_keys:
        self._projectmanager._project_list[index]._project_components[key] = entry[key].get_text()
      self.remove_page(index)
      self.create_new_tab(index)
    else:
      #      print "Bad response !!!"
      pass
    dial.destroy()
      
  def refresh(self, parent):
    index = self.get_current_page()
    self.remove_page(index)
    self.create_new_tab(index)
    

class ILPView:
    ui = '''<ui>
    <menubar name="BarreMenu">
      <menu action="File">
        <menuitem action="New"/>
        <menuitem action="Edit"/>
        <menuitem action="Open"/>
        <menuitem action="Save"/>
        <menuitem action="Close"/>
        <menuitem action="Quit"/>
      </menu>
      <menu action="Tools">
        <menuitem action="Profile"/>
        <menuitem action="Histogram"/>
        <menuitem action="Trace"/>
        <menuitem action="Clean"/>
      </menu>
      <menu action="View">
        <menuitem action="ViewProfile"/>
        <menuitem action="ViewHistogram"/>
        <menuitem action="ViewEPSHistogram"/>
        <menuitem action="ViewTraceA"/>
      </menu>
      <menu action="Preferences">
        <menuitem action="Change"/>      
      </menu>
    </menubar>
    <toolbar name="ToolBar1">
      <toolitem action="New"/>
      <toolitem action="Edit"/>
      <toolitem action="Open"/>
      <toolitem action="Save"/>
      <toolitem action="Close"/>
    </toolbar>
    <toolbar name="ToolBar2">
      <toolitem action="Profile"/>
      <toolitem action="Histogram"/>
      <toolitem action="Trace"/>
      <toolitem action="Clean"/>
      <separator/>
      <toolitem action="ViewProfile"/>
      <toolitem action="ViewHistogram"/>
      <toolitem action="ViewEPSHistogram"/>
      <toolitem action="ViewTraceA"/>
      <separator/>
    </toolbar>
    </ui>'''
      
    #      <toolitem action="ViewTraceG"/>
    def __init__(self, setup=None, projectmanager=None):
        # Créer la fenêtre de premier niveau
        self.window = gtk.Window()
        self.window.connect('destroy', lambda w: gtk.main_quit())
        #        self.window.set_size_request(640, 480)
        self.window.set_size_request(640, 480)
        self.window.resize(940, 600)
        vbox = gtk.VBox()
        self.window.add(vbox)
        self._setup = setup
        self._projectmanager = projectmanager

        self._showview = ILPShow.ILPShow()
        # Créer une instance du UIManager
        gestionui = gtk.UIManager()

        # Ajouter le groupe de raccourcis à  la fenêtre de premier niveau
        grouperacc = gestionui.get_accel_group()
        self.window.add_accel_group(grouperacc)

        # Créer un ActionGroup
        actiongroup1 = gtk.ActionGroup('FILE')
        actiongroup2 = gtk.ActionGroup('TOOLS')
        actiongroup3 = gtk.ActionGroup('SHOW')
        actiongroup4 = gtk.ActionGroup('PREFS')
        
        self.actiongroup1 = actiongroup1
        self.actiongroup2 = actiongroup2
        self.actiongroup3 = actiongroup3
        self.actiongroup4 = actiongroup4

        # Créer une ToggleAction, etc.
        #         groupeactions.add_toggle_actions([('Volume', None, '_Volume', '<Control>v',
        #                                          'Niveau de son', self.rappel_volume)])

        # Créer les actions
        actiongroup1.add_actions([('Quit', gtk.STOCK_QUIT, '_Quit!', None,
                                    'Bye bye...', self.rappel_quitte),
                                   ('File', None, '_File'),
                                   ('New', gtk.STOCK_NEW, '_New', None, None, self.New),
                                   ('Edit', gtk.STOCK_EDIT, '_Edit', None, None, self.Edit),
                                   ('Open', gtk.STOCK_OPEN, '_Open', None, None, self.Open),
                                   ('Save', gtk.STOCK_SAVE, '_Save', None, None, self.Save),
                                   ('Close', gtk.STOCK_CLOSE, '_Close')
                                   ])
        actiongroup2.add_actions([
                                   ('Tools', None, '_Tools'),
                                   ('Profile', gtk.STOCK_MEDIA_PLAY, '_Prof', None, None, self.Profile),
                                   ('Histogram', gtk.STOCK_EXECUTE, '_Histo', None, None, self.Histogram),
                                   # ('ShortHisto', gtk.STOCK_EXECUTE, '_SHisto', None, None, self.ShortHistogram),
                                   ('Trace', gtk.STOCK_SORT_DESCENDING, '_Trace', None, None, self.Trace),
                                   ('Clean', gtk.STOCK_CLEAR, '_Clean', None, None, self.Clean)
                                   ])
        actiongroup3.add_actions([
                                   ('View', None, '_View'),
                                   ('ViewProfile', gtk.STOCK_ZOOM_FIT, '_ViewProf', None, None, self.ViewProfile),
                                   ('ViewHistogram', gtk.STOCK_SELECT_COLOR, '_ViewHisto', None, None, self.ViewHistogram),
                                   ('ViewEPSHistogram', gtk.STOCK_SELECT_COLOR, '_ViewEPSHisto', None, None, self.ViewEPSHistogram),
                                   # ('ViewShortHisto', gtk.STOCK_SELECT_COLOR, '_ViewShortHisto', None, None, self.ViewShortHistogram),
                                   ('ViewTraceA', gtk.STOCK_ZOOM_FIT, '_ViewTraceA', None, None, self.ViewTraceA),
                                   # ('ViewTraceS', gtk.STOCK_ZOOM_FIT, '_ViewTraceS', None, None, self.ViewTraceS),
                                   # ('ViewTraceG', gtk.STOCK_ZOOM_FIT, '_ViewTraceG', None, None, self.ViewTraceG)
                                   ])
        actiongroup4.add_actions([
                                   ('Preferences', None, '_Preferences'),
                                   ('Change', None, '_Change', None, None, self.Change)
                                   ])

        actiongroup1.get_action('Quit').set_property('short-label', '_Quit')

        # Créer quelques RadioActions
#         groupeactions.add_radio_actions([('MA', None, '_MA', '<Control>m',
#                                         "Modulation d'amplitude", 0),
#                                        ('MF', None, 'M_F', '<Control>f',
#                                         'Modulation de fréquence', 1),
#                                        ('BLU', None, '_BLU', '<Control>b',
#                                         'Bande latérale unique', 2),
#                                        ], 0, self.rappel_modulation)

        # Ajouter le groupe d'action au gestionnaire d'interface
        gestionui.insert_action_group(actiongroup1, 0)
        gestionui.insert_action_group(actiongroup2, 1)
        gestionui.insert_action_group(actiongroup3, 2)
        gestionui.insert_action_group(actiongroup4, 3)

        # Ajouter une description d'Interface Utilisateur
        gestionui.add_ui_from_string(self.ui)

        # Créer la barre de menus
        barremenus = gestionui.get_widget('/BarreMenu')
        vbox.pack_start(barremenus, False)

        # Créer la barre d'outils
        toolbar1 = gestionui.get_widget('/ToolBar1')
        vbox.pack_start(toolbar1, False)

        toolbar2 = gestionui.get_widget('/ToolBar2')
        vbox.pack_start(toolbar2, False)

        self.projectbook = ProjectNotebook(self._projectmanager)
        vbox.pack_start(self.projectbook)

        toolbar1.show_all()
        toolbar2.show_all()
        self.window.show_all()
        return

    def Change(self, d):
      dial = gtk.Dialog("Preferences", self.window, gtk.DIALOG_MODAL,
                        (gtk.STOCK_SAVE, gtk.RESPONSE_OK,
                         gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
      dial.resize(640,10)
      # Creation de la zone de saisie
      entry_pinpath = gtk.Entry()
      entry_pinpath.set_text(self._setup._pinpath)      
      entry_pinoptions = gtk.Entry()
      entry_pinoptions.set_text(self._setup._pinoptions)      
      entry_pintoolpath = gtk.Entry()
      entry_pintoolpath.set_text(self._setup._pintoolpath)      
      dial.vbox.pack_start(gtk.Label("PIN Path: "), True, False, 0)
      dial.vbox.pack_start(entry_pinpath, True, False, 0)
      dial.vbox.pack_start(gtk.Label("PIN Options: "), True, False, 0)
      dial.vbox.pack_start(entry_pinoptions, True, False, 0)
      dial.vbox.pack_start(gtk.Label("PIN Tool path: "), True, False, 0)
      dial.vbox.pack_start(entry_pintoolpath, True, False, 0)
      dial.vbox.show_all()
      # On lance la boite de dialogue et on recupere la reponse
      reponse = dial.run()
      if reponse == gtk.RESPONSE_OK:
        # L'utilisateur valide
        self._setup._pinpath = entry_pinpath.get_text()
        self._setup._pinoptions = entry_pinoptions.get_text()
        self._setup._pintoolpath = entry_pintoolpath.get_text()
        self._setup.SavePreferences()
        pass
      dial.destroy()
      
    def New(self, d):
      index = self._projectmanager.Create()
      print 'INDEX = ', index
      self.projectbook.create_new_tab(index)
      for i in range(0,len(self._projectmanager._project_list)):
        print self._projectmanager._project_list[i]
        print 'PROJECTLIST[', i,']     ',
        print self._projectmanager._project_list[i]._project_components['name']

    def Edit(self, d):
      self.projectbook.edit(self.window)
      #       for i in range(0,len(self._projectmanager._project_list)):
      #         print 'PROJECTLIST[', i,']     ',
      #         print self._projectmanager._project_list[i]._project_components['name']
      self.Save(d)
      pass

    def Open(self, d):
      chooser = gtk.FileChooserDialog(title="Open",action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      #       chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
      #                                       buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Project files")
      myfilter.add_pattern("*.project")
      chooser.add_filter(myfilter)
      chooser.set_current_folder(self._setup._absilpdir+self._setup._project_directory)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        projectname = chooser.get_filename()
        print chooser.get_filename(), 'selected'
        self._projectmanager.Open(projectname)
        self.projectbook.create_new_tab(len(self._projectmanager._project_list)-1)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
      chooser.destroy()
      pass

    def AutoOpen(self, name):
      #      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
      #                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      #       chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
      #                                       buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      #       myfilter = gtk.FileFilter()
      #       myfilter.set_name("Project files")
      #       myfilter.add_pattern("*.project")
      #       chooser.add_filter(myfilter)
      #       response = chooser.run()
      #       if response == gtk.RESPONSE_OK:
      projectname = name
      #      print chooser.get_filename(), 'selected'
      self._projectmanager.Open(projectname)
      self.projectbook.create_new_tab(len(self._projectmanager._project_list)-1)
      #       elif response == gtk.RESPONSE_CANCEL:
      #         print 'Closed, no files selected'
      #       chooser.destroy()
      pass

    def Save(self, d):
      current = self.projectbook.get_current_page()
      self._projectmanager.Save(current)
      pass

    def Profile(self, d):
      print "[GETTING PROFILE]"
      current = self.projectbook.get_current_page()
      self._projectmanager.Profile(current)
      self.projectbook.refresh(self.window)
      pass
      
    def Histogram(self, d):
      print "[GETTING HISTOGRAM]"
      current = self.projectbook.get_current_page()
      self._projectmanager.Histogram(current)
      pass
      
    def ShortHistogram(self, d):
      print "[GETTING SHORT HISTOGRAM]"
      current = self.projectbook.get_current_page()
      self._projectmanager.ShortHistogram(current)
      pass
      
    def Trace(self, d):
      print "[GETTING TRACE]"
      current = self.projectbook.get_current_page()
      self._projectmanager.Trace(current)
      pass
      
    def Clean(self, d):
      current = self.projectbook.get_current_page()
      self._projectmanager.Clean(current)
      pass

    def ViewProfile(self, d):
      print "[SHOW PROFILE]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      #ILPView.ILPView.ViewProfile()
      text = self._showview.ViewProfile(self._projectmanager._project_list[current]._ilpfiles['profile'])
      if text != None:
        #        print text
        textbuffer = gtk.TextBuffer()
        textbuffer.set_text(text)
        #        print textbuffer
        textview = gtk.TextView(textbuffer)
        textview.set_editable(False)
        textview.set_cursor_visible(False)
        dial = gtk.Dialog("Preferences", self.window, gtk.DIALOG_MODAL,
                          (gtk.STOCK_CLOSE, gtk.RESPONSE_OK,
                           ))
        dial.resize(640,640)
        scrolled_window = gtk.ScrolledWindow()
        scrolled_window.add_with_viewport(textview)
        textview.show()
        dial.vbox.pack_start(scrolled_window, True, True, 0)
        scrolled_window.show()
        dial.run()
        dial.destroy()
        
      os.chdir(os.pardir)
      pass
      
    def ViewHistogram(self, d):
      print "[SHOW HISTOGRAM]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewHistogram()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Histogram files")
      myfilter.add_pattern("*.histogram")
      #      myfilter.add_pattern("*.shorthistogram")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        histoname = chooser.get_filename()
        print chooser.get_filename()
        self._showview.ViewHistogram(histoname)
        #        self._projectmanager.Open(projectname)
        #        self.projectbook.create_new_tab(len(self._projectmanager._project_list)-1)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
      chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
    def ViewEPSHistogram(self, parent):
      keyvalue = {}
      keyvalue["htitle"] = "blank"
      keyvalue["xmin"] = ""
      keyvalue["xmax"] = ""
      keyvalue["ymin"] = ""
      keyvalue["ymax"] = ""

      keylist = ["htitle", "xmin", "xmax", "ymin", "ymax"]

      print "[CUSTOMIZE YOUR EPS HISTOGRAM]"
      dial = gtk.Dialog("Customize your EPS output", self.window, gtk.DIALOG_MODAL,
                        (gtk.STOCK_OK, gtk.RESPONSE_OK,
                         gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
      dial.resize(480,300)
      #    dial.set_size_request(480,200)
      # Creation de la zone de saisie
      
      entry = {}
      labels = {}
      for key in keylist:
        labels[key] = gtk.Label(key)
        labels[key].modify_font(pango.FontDescription("Courier New italic bold 10"))
        entry[key] = gtk.Entry()
        entry[key].set_text("")
      for key in keylist:
        dial.vbox.pack_start(labels[key])
        dial.vbox.pack_start(entry[key], True, False, 0)
          
      dial.vbox.show_all()
      # On lance la boite de dialogue et on recupere la reponse
      reponse = dial.run()
      if reponse == gtk.RESPONSE_OK:
        #print "Histo Title"+ entry["htitle"].get_text()
        #print entry["xmin"].get_text(), entry["xmax"].get_text(), entry["ymin"].get_text(), entry["ymax"].get_text()
        for key in keylist:
          keyvalue[key] = entry[key].get_text()
          print key+"\t: " +keyvalue[key]
        # L'utilisateur valide
            #for key in keylist:
            #xmin = entry[key].get_text()
      #self.remove_page(index)
      #self.create_new_tab(index)
      #pass
      else:
        #      print "Bad response !!!"
        pass
      dial.destroy()

      print "[SHOW HISTOGRAM]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewHistogram()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Histogram files")
      myfilter.add_pattern("*.histogram")
      #      myfilter.add_pattern("*.shorthistogram")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        histoname = chooser.get_filename()
        print chooser.get_filename()
        self._showview.ViewEPSHistogram(histoname, keyvalue["htitle"], keyvalue["xmin"], keyvalue["xmax"], keyvalue["ymin"], keyvalue["ymax"])
        #        self._projectmanager.Open(projectname)
        #        self.projectbook.create_new_tab(len(self._projectmanager._project_list)-1)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
      chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
    def ViewShortHistogram(self, d):
      print "[SHOW HISTOGRAM]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewHistogram()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Short Histogram files")
      #      myfilter.add_pattern("*.histogram")
      myfilter.add_pattern("*.shorthistogram")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        histoname = chooser.get_filename()
        print chooser.get_filename()
        self._showview.ViewShortHistogram(histoname)
        #        self._projectmanager.Open(projectname)
        #        self.projectbook.create_new_tab(len(self._projectmanager._project_list)-1)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
      chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
    def ViewTraceA(self, d):
      print "[SHOW TRACE ALL]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewTrace()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Trace files")
      myfilter.add_pattern("*.trace")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        tracename = chooser.get_filename()
        chooser.destroy()
        #print chooser.get_filename()
        self._showview.ViewTraceA(tracename)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
        chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
    def ViewTraceS(self, d):
      print "[SHOW TRACE SELECTED]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewTrace()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Trace files")
      myfilter.add_pattern("*.trace")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        tracename = chooser.get_filename()
        print chooser.get_filename()
        self._showview.ViewTraceS(tracename, self.window)
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
      chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
    def ViewTraceG(self, d):
      print "[SHOW TRACE GROUP]"
      current = self.projectbook.get_current_page()
      directory = self._projectmanager._project_list[current]._project_components['name']
      os.chdir(directory)
      
      #      ILPView.ILPView.ViewTrace()
      chooser = gtk.FileChooserDialog(title=None,action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                      buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
      myfilter = gtk.FileFilter()
      myfilter.set_name("Trace files")
      myfilter.add_pattern("*.trace")
      chooser.set_current_folder(directory)
      chooser.add_filter(myfilter)
      response = chooser.run()
      if response == gtk.RESPONSE_OK:
        tracename = chooser.get_filename()
        chooser.destroy()
        #print chooser.get_filename()
        self._showview.ViewTraceG(tracename)
        
      elif response == gtk.RESPONSE_CANCEL:
        print 'Closed, no files selected'
        chooser.destroy()
      
      os.chdir(os.pardir)
      pass
      
#     def ViewTrace(self, d):
#       print "[SHOW TRACE]"
#       current = self.projectbook.get_current_page()
#       directory = self._projectmanager._project_list[current]._project_components['name']
#       os.chdir(directory)
#       #      ILPView.ILPView.ViewProfile()
#       os.chir(os.pardir)
#       pass

    def rappel_quitte(self, b):
      self._projectmanager.Quit()
      print 'Bye bye...'
      gtk.main_quit()

    def change_sensible(self, b):
        self.actiongroup2.set_sensitive(b.get_active())
        return

    def change_visible(self, b):
        self.actiongroup3.set_visible(b.get_active())
        return

    pass
  
